<?php

/**
 * co_campo_modadlidad actions.
 *
 * @package    contratacion
 * @subpackage co_campo_modadlidad
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_campo_modadlidadActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_CAMPO_MODALIDAD','CO_CAMPO_EP','CO_MODALIDAD_SEL'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_MODALIDAD_SEL' =>
         array (
            'id_modalidad_sel' => 'CO_CAMPO_MODALIDAD'
         ),
        'CO_CAMPO_EP'=>
        array(
            'id_campo_ep'=>'CO_CAMPO_MODALIDAD'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_CAMPO_MODALIDAD' =>
       array(
            'id_campo_modalidad' => 'id_campo_modalidad',
            'id_campo_ep' => 'id_campo_ep',
            'id_modalidad_sel' => 'id_modalidad_sel',
            'orden' => 'orden',
            'estado' => 'estado'
        ),
        'CO_MODALIDAD_SEL'=>
        array(
            'prefijo' => 'prefijo_modalidad',
            'descripcion' => 'descripcion_modalidad'
        ),
        'CO_CAMPO_EP'=>
        array(
            'descripcion' => 'descripcion_campoep',
            'campo_fijo' => 'campo_fijo'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_CAMPO_MODALIDAD' =>
        array(    
            'id_campo_modalidad,a' => array('!=' => array(-1)),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_MODALIDAD_SEL'=>
        array(
            'prefijo,a' => array('LIKEALLPLUS' => array('prefijo_modalidad', '%')),
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion_modalidad', '%'))
        ),
        'CO_CAMPO_EP'=>
        array(
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion_campoep', '%')),
            'campo_fijo' => array('=' => array('campo_fijo'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_campo_modalidad'; //identificador de la tabla
    protected $id_names = array('id_campo_modalidad'); //llave primaria
    protected $field_names = array('id_campo_ep', 'id_modalidad_sel', 'orden','estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CAMPO_MODALIDAD'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_campo_modalidad'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        $config = HTMLPurifier_Config::createDefault();
        $purifier = new HTMLPurifier($config);
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $valor = $request['default_value'];
            $valor_limpio = $purifier->purify($valor);
            $request['default_value'] = $valor_limpio;
            
        }

        //accion update
        if ($Action == "UPDATE") {
            $valor = $request['default_value'];
            $valor_limpio = $purifier->purify($valor);
            $request['default_value'] = $valor_limpio;
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_campo_modalidad = $request['id_campo_modalidad'];
        
        $sql = <<<EOD
        select count(*) as cantidad
from
co_detalle_ep tab0
join co_estudios_previos tab1 on tab1.ID_ESTUDIOS_PREVIOS = tab0.ID_ESTUDIOS_PREVIOS
join co_modalidad_sel tab2 on tab2.ID_MODALIDAD_SEL = tab1.ID_MODALIDAD_SEL
join co_campo_modalidad tab3 on tab3.CAMPO_EP.id_campo_ep = tab0.ID_CAMPO_EP and tab3.ID_MODALIDAD_SEL=tab1.ID_MODALIDAD_SEL
where tab3.ID_CAMPO_MODALIDAD = $id_campo_modalidad
EOD;
        $records = CN_TABLE::executeSQL($sql);
        
        $cantidad = $records[0]['cantidad'];

        /*
         *  Generar errores en $errors
         */
        if($cantidad>0){
            $errors['mensaje'] = "No se puede eliminar, Existen estudios previos utilizando el campo de la modalidad.";
            $errors['servicio'] = "co_campo_modalidad";
        }

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    } 
    
    private function htmlClear($string) {




        $string = str_replace('<p>', '<p align="justify">', $string);
        $string = str_replace('<br>', '<br/>', $string);
        $string = str_replace('class=', '', $string);
        $string = str_replace('<img', '', $string);
        $string = str_replace('<td>X</td>', '<td align="center">X</td>', $string);
        $string = str_replace('<td rowspan="2">', '<td rowspan="2" align="justify">', $string);

        $string = str_replace('<font size="2">', '<font size="10">', $string);
        $string = str_replace('<font size="3">', '<font size="12">', $string);
        $string = str_replace('<font size="4">', '<font size="14">', $string);
        $string = str_replace('<font size="5">', '<font size="18">', $string);
        $string = str_replace('<font size="6">', '<font size="24">', $string);
        $string = str_replace('<font size="7">', '<font size="36">', $string);
        $string = str_replace('<table ', '<center><table ', $string);
        $string = str_replace('</table> ', '</table></center>', $string);
        $string = str_replace('<table ', '<table border="1"', $string);

        $string = str_replace('size="1"', 'size="10"', $string);
        $string = str_replace('size="2"', 'size="10"', $string);
        $string = str_replace('size="3"', 'size="12"', $string);
        $string = str_replace('size="4"', 'size="14"', $string);
        $string = str_replace('size="5"', 'size="18"', $string);
        $string = str_replace('size="6"', 'size="24"', $string);
        $string = str_replace('size="7"', 'size="36"', $string);

        $string = str_replace('border="0"', 'border="1"', $string);


        $string = str_replace('<div>', '<div align="justify">', $string);
        $string = str_replace('&amp;amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;nbsp;', '', $string);
        $string = str_replace('&amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;nbsp;', '', $string);
        $string = str_replace('amp;', '', $string);

        $string = str_replace('<td colspan="2">', '<td colspan="2" align="justify">', $string);
        $string = str_replace('<td rowspan="3">', '<td rowspan="3" align="justify">', $string);
        $string = str_replace('<td colspan="3">', '<td colspan="3" align="justify">', $string);
        $string = str_replace('<td rowspan="4">', '<td rowspan="4" align="justify">', $string);
        $string = str_replace('<td colspan="4">', '<td colspan="4" align="justify">', $string);
        $string = str_replace('  ', ' ', $string);
        $string = str_replace('   ', ' ', $string);
        $string = str_replace('    ', ' ', $string);
        $string = str_replace('	    ', ' ', $string);
        $string = str_replace('		    ', ' ', $string);
        $string = str_replace('valign', 'align', $string);
        $string = str_replace('width=', '', $string);
        $string = str_replace('bordercolor=', '', $string);
        $string = str_replace('<td>', '<td align="justify">', $string);
        $string = str_replace('<li>', '<li align="justify">', $string);
        $string = str_replace('style=', '', $string);

        return trim($string);
    }
}
